﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataChartScatterDateCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel VM = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = VM;


            XamDataChart chart = new XamDataChart();

            NumericXAxis xAxis = new NumericXAxis();

            DataTemplate DT = GetLabelTemplate();

            xAxis.Label = DT;

            NumericYAxis yAxis = new NumericYAxis();

            ScatterSeries series = new ScatterSeries();
            series.XAxis = xAxis;
            series.YAxis = yAxis;
            series.ItemsSource = VM.Data;
            series.XMemberPath = "Ticks";
            series.YMemberPath = "YValue";

            chart.Axes.Add(xAxis);
            chart.Axes.Add(yAxis);

            chart.Series.Add(series);

            LayoutRoot.Children.Add(chart);

        }

        public DataTemplate GetLabelTemplate()
        {
            DataTemplate DT = new DataTemplate();

            FrameworkElementFactory fef = new FrameworkElementFactory(typeof(TextBlock));

            Binding b = new Binding("Item");
            b.Converter = new MyTicksToDateConverter();

            fef.SetBinding(TextBlock.TextProperty, b);

            DT.VisualTree = fef;

            return DT;
        }
    }
}
